<template>
  <div>
    <template v-if="show">
      <v-slide-group
        v-if="this.node[0].idModeloNegocioPadre === 1"
        v-model="selected"
        class="pa-4"
        show-arrows
        center-active
      >
        <template v-for="(nivel, index) in node">
          <v-slide-item :key="index" v-slot="{ active, toggle }" :value="nivel">
            <v-hover v-slot="{ hover }">
              <v-card
                :style="'background-color : ' + nivel.nombre"
                class="ma-2 rounded-lg border-buttom"
                :class="[{ tenue: !active && selected }]"
                :height="hover ? 130 : 110"
                width="250"
                @click="toggle"
              >
                <div class="d-flex flex-no-wrap">
                  <v-avatar class="ma-3" size="80" tile>
                    <Icono :uid="nivel.icono" />
                  </v-avatar>
                  <v-card-subtitle
                    class="white--text subtitle-1 align-self-center pa-0 pr-1"
                  >
                    {{ nivel.descripcion }}
                  </v-card-subtitle>
                </div>
              </v-card>
            </v-hover>
          </v-slide-item>
        </template>
      </v-slide-group>
      <v-chip-group
        v-if="this.node[0].idModeloNegocioPadre > 1"
        v-model="selected"
        active-class="primary--text"
      >
        <template v-for="(nivel, index) in node">
          <v-chip
            :disabled="disabled"
            class="ma-1 "
            label
            active-class="chip-selected"
            :color="nivel.nombre"
            :value="nivel"
            link
            outlined
            pill
            :key="index"
            >{{ nivel.descripcion }}</v-chip
          >
        </template>
      </v-chip-group>
      <template v-if="node && node.length > 0 && selected && selected.children">
        <Component-Arbol
          ref="componentArbol"
          :disabled="disabled"
          v-model="vmodel"
          :node="selected.children"
          :parent="selected"
          :color="selected.nombre"
        />
      </template>
    </template>
  </div>
</template>
<style scoped>
.tenue {
  opacity: 0.5;
}
</style>
<style>
.border-buttom {
  border-color: rgb(0 0 0 / 50%) !important;
  border-bottom-width: 8px;
  border-bottom-style: solid;
}
.v-chip.v-chip--outlined.v-chip.v-chip {
  border: 2px solid;
}
.v-chip.v-chip--outlined.v-chip.v-chip.chip-selected {
}
</style>
<script>
import Icono from "@/views/secure/modelo-negocio//documentos/visualizador/folios/usuario/publicados/components/Icono.vue";
export default {
  name: "Component-Arbol",
  components: {
    Icono,
  },
  props: {
    value: null,
    node: {
      type: Array,
      required: true,
    },
    parent: {
      type: [String, Object],
      required: true,
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    return {
      selected: null,
      show: true,
      vmodel: null,
    };
  },
  watch: {
    vmodel(val, prev) {
      if (val) {
        this.$emit("input", val);
      } else {
        this.$emit("input", this.selected);
      }
    },
    parent(val) {
      if (val) {
        this.selected = null;
      }
    },
    selected(val, prev) {
      this.$emit("input", val);
      if (this.selected && this.selected.idModeloNegocioPadre === 1) {
        localStorage.setItem("color", this.selected.nombre);
      }
    },
  },
  computed: {
    color() {
      return localStorage.getItem("color");
    },
  },
  methods: {
    clear() {
      if (this.$refs.componentArbol) {
        this.selected = null;
      }
    },
  },
  created() {},
};
</script>
